:h1 id=regex res=300. ࠦ
:p.
 拉 ४⨢
:link reftype=hd refid=cfgFiles.䨣樮 䠩:elink.
ਬ ॣ ࠦ  ⨫ Unix System 8. 
 ॣ ࠦ ᭮ 
:xmp.
regexp - Copyright (c) 1986 by University of Toronto. Written by Henry Spencer.
:exmp.
:p.:hp2.1. Syntax:ehp2.
:p.
A regular expression is zero or more branches, separated by :hp9.|:ehp9.. It
matches anything that matches one of the branches.
:p.
A branch is zero or more pieces, concatenated. It matches a match for
the first, followed by a match for the second, etc.
:p.
A piece is an atom possibly followed by :hp9.*:ehp9., :hp9.+:ehp9., or :hp9.?:ehp9.. An atom
followed by :hp9.*:ehp9. matches a sequence of 0 or more matches of the atom.
An atom followed by :hp9.+:ehp9. matches a sequence of 1 or more matches of the
atom. An atom followed by :hp9.?:ehp9. matches a match of the atom, or the null
string.
:p.
An atom is a regular expression in parentheses (matching a match for
the regular expression), a range (see below), :hp9..:ehp9. (matching any single
character), :hp9.^:ehp9. (matching the null string at the beginning of the input
string), :hp9.$:ehp9. (matching the null string at the end of the input string),
a :hp9.\:ehp9. followed by a single character (matching that character), or a
single character with no other significance (matching that character).
:p.
A range is a sequence of characters enclosed in :hp9.[]:ehp9.. It normally
matches any single character from the sequence. If the sequence
begins with :hp9.^:ehp9., it matches any single character not from the rest of
the sequence. If two characters in the sequence are separated by :hp9.-:ehp9.,
this is shorthand for the full list of ASCII characters between them
(e.g. :hp9.[0-9]:ehp9. matches any decimal digit). To include a literal :hp9.]:ehp9. in
the sequence, make it the first character (following a possible :hp9.^:ehp9.).
To include a literal :hp9.-:ehp9., make it the first or last character.

:p.:hp2.2. Ambiguity:ehp2.
:p.
If a regular expression could match two different parts of the input
string, it will match the one which begins earliest. If both begin in
the same place but match different lengths, or match the same length in
different ways, life gets messier, as follows.
:p.
In general, the possibilities in a list of branches are considered in
left-to-right order, the possibilities for :hp9.*:ehp9., :hp9.+:ehp9., and :hp9.?:ehp9. are
considered longest-first, nested constructs are considered from the
outermost in, and concatenated constructs are considered leftmost-first.
The match that will be chosen is the one that uses the
earliest possibility in the first choice that has to be made. If there
is more than one choice, the next will be made in the same manner
(earliest possibility) subject to the decision on the first choice.
And so forth.
:p.
For example, :hp9.(ab|a)b*c:ehp9. could match :hp9.abc:ehp9. in one of two ways. The
first choice is between :hp9.ab:ehp9. and :hp9.a:ehp9.; since :hp9.ab:ehp9. is earlier, and does
lead to a successful overall match, it is chosen. Since the :hp9.b:ehp9. is
already spoken for, the :hp9.b*:ehp9. must match its last possibility-the empty
string-since it must respect the earlier choice.
:p.
In the particular case where no :hp9.|:ehp9.s are present and there is only
one :hp9.*:ehp9., :hp9.+:ehp9., or :hp9.?:ehp9., the net effect is that the longest possible
match will be chosen. So :hp9.ab*:ehp9., presented with :hp9.xabbbby:ehp9., will match
:hp9.abbbb:ehp9.. Note that if :hp9.ab*:ehp9. is tried against :hp9.xabyabbbz:ehp9., it will
match :hp9.ab:ehp9. just after :hp9.x:ehp9., due to the begins-earliest rule. (In effect,
the decision on where to start the match is the first choice to be
made, hence subsequent choices must respect it even if this leads them
to less-preferred alternatives.)
